package jitas.util;

import java.util.ArrayList;
import java.util.List;

/**
 * Tokenise string by the JITAS default JESS parser.
 *  
 * @author	DeathMarch (c314g2)
 * @version	27 September 2007
 */
public class DefaultJESSParser implements JESSParser{
	/**
	 * Return a list of strings that has been tokenised by the JITAS default JESS parser
	 * @param str String to be tokenised
	 * @return List<String> The list of Strings tokenised
	 */
	public List<String> tokenise(String str){
		str = str + "    "; // to stop index out of bounds exceptions
		int p = 0;
		List<String> strings = new ArrayList<String>();
		while (p < str.length()) {
			int old = p;
			if (str.charAt(p) == ' ') p++;
			else if (str.charAt(p) == '\'') {
				p++;
				while (str.charAt(p) != '\'') p++;
				strings.add(str.substring(old+1, p));
				p++;
			}			
			else if ((str.charAt(p) >= 'a' && str.charAt(p) <= 'z' ||
					str.charAt(p) >= 'A' && str.charAt(p) <= 'Z')) {
			
				while((str.charAt(p) >= 'a' && str.charAt(p) <= 'z' ||
						str.charAt(p) >= 'A' && str.charAt(p) <= 'Z')) {
					p++;				
				}
				if (p != old) strings.add(str.substring(old, p));
			}			
			else if (str.charAt(p) == ',') strings.add("" + str.charAt(p++));
			else if (str.charAt(p) == '.') strings.add("" + str.charAt(p++));
			else if (str.charAt(p) == ';') strings.add("" + str.charAt(p++));
			else if (str.substring(p, p+4).equals("(, )")) {
				strings.add(str.substring(p, p+4));
				p+=4;
			}
			else if (str.substring(p, p+4).equals("{, }")) {
				strings.add(str.substring(p, p+4));
				p+=4;
			}
			else if (str.substring(p, p+2).equals("<=")) {
				strings.add(str.substring(p, p+2));
				p+=2;
			}
			else if (str.substring(p, p+2).equals(">=")) {
				strings.add(str.substring(p, p+2));
				p+=2;
			}
			else if (str.substring(p, p+2).equals("!=")) {
				strings.add(str.substring(p, p+2));
				p+=2;
			}
			else if (str.substring(p, p+2).equals("==")) {
				strings.add(str.substring(p, p+2));
				p+=2;
			}
			else if (str.substring(p, p+2).equals("&&")) {
				strings.add(str.substring(p, p+2));
				p+=2;
			}
			else if (str.substring(p, p+2).equals("||")) {
				strings.add(str.substring(p, p+2));
				p+=2;
			}
			else if (str.charAt(p) == '+') strings.add("" + str.charAt(p++));
			else if (str.charAt(p) == '-') strings.add("" + str.charAt(p++));
			else if (str.charAt(p) == '/') strings.add("" + str.charAt(p++));
			else if (str.charAt(p) == '*') strings.add("" + str.charAt(p++));
			else if (str.charAt(p) == '=') strings.add("" + str.charAt(p++));
			else if (str.charAt(p) == '%') strings.add("" + str.charAt(p++));
			else if (str.charAt(p) == '!') strings.add("" + str.charAt(p++));
			else if (str.charAt(p) == '^') strings.add("" + str.charAt(p++));
			else if (str.charAt(p) == '&') strings.add("" + str.charAt(p++));
			else if (str.charAt(p) == '|') strings.add("" + str.charAt(p++));
			
			// just to stop if from infinitaly looping...
			else if (p == old) p++;
		}
		return strings;
	}
}
