package jitas.util;

import java.util.List;
/**
 * The interface class for the Java Intelligent Tutor Authoring Shell (JITAS)
 * JESS Parser. Interfacing client will use this class to implement
 * domain-specific parser.
 * @author	DeathMarch (c314g2)
 * @version	27 September 2007
 */
public interface JESSParser {
	/**
	 * Return a list of Strings that has been tokenise
	 * This design pattern aims to increase flexibility for client to add/use their
	 * own solution evaluator parser
	 * @param str String to be tokenised.
	 * @return List list of strings
	 */
	public List<String> tokenise(String str);
}
