package jitas.unittest;

import junit.framework.TestCase;

import java.util.Iterator;
import java.util.Set;

import jitas.core.*;
import jitas.xml.parser.DomainParser;

/* 
 * @author	DeathMarch (c314g2)
 * @version	8 October 2007
 */
public class DomainParserTest extends TestCase{

	private DomainParser dp;
	
	protected void setUp() throws Exception {
		super.setUp();
		dp = new DomainParser("german");
	}

	protected void tearDown() throws Exception {
		super.tearDown();
		dp = null;
	}
	
	public void testprocessTree() {
		Domain d;
		Set<Subdomain> subdomains;
		try {
			d = dp.processTree();
			assertTrue(d.getDescription().equals("Something to teach you german"));
			assertTrue(d.getName().equals("german"));
			assertTrue(d.getType().equals("HTML"));
			assertTrue(d.userCreationAllowed()==true);
			
			subdomains = d.getSubdomains();
			Iterator<Subdomain> i = subdomains.iterator();
			Subdomain s = i.next();
			
			if(s.getName().equals("adjectives")) {
				assertTrue(s.getDescription().equals("adjective endings"));
				s = i.next();
				assertTrue(s.getName().equals("verbs"));
				assertTrue(s.getDescription().equals("verb endings"));
			} else if(s.getName().equals("verbs")){
				assertTrue(s.getDescription().equals("verb endings"));
				s = i.next();
				assertTrue(s.getName().equals("adjectives"));
				assertTrue(s.getDescription().equals("adjective endings"));				
			} else fail();
			
		} catch(Exception e) {
			e.printStackTrace();
			fail("caught an exception in testProcessTree");
		}
	}
}








