package jitas.unittest;
import java.io.File;

import junit.framework.*;
import jitas.core.*;
import jitas.exception.*;
import jitas.xml.writer.StudentModelWriter;

/* 
 * @author	DeathMarch (c314g2)
 * @version	8 October 2007
 */
public class StudentModelWriterTest extends TestCase {
	StudentModel sm;
	Domain domain;
	String studentModelLocation = "testfiles/testdomains/anotherdomain/student-models.xml";
	File studentModels;

	protected void setUp() throws Exception {
		super.setUp();

		Process p = Runtime.getRuntime().exec("./testfiles/copy-out-testdomains.sh");
		p.waitFor();
		domain = new Domain("testDomain", "the test domain", "this is a test domain", true, "type","subdomainTerm", null);
		sm = new StudentModel("Louis");
	}

	protected void tearDown() throws Exception {
		super.tearDown();

		Process p = Runtime.getRuntime().exec("./testfiles/delete-testdomains.sh");
		p.waitFor();
	}


	public void testStudentModelWriter() {
		StudentModelWriter smw = new StudentModelWriter(sm, studentModelLocation);
		smw.addStudentModel();
		try {
			smw.removeStudentModel();
		} catch (UserNotFoundException e) {
			e.printStackTrace();
			fail();
		}

		try {
			smw.persistStudentModel();
			fail();
		} catch(UserNotFoundException e) {
			//Expected :)
		}

		smw.addStudentModel();
		try {
			smw.persistStudentModel();
		} catch (UserNotFoundException e) {
			fail();
		}

	}
}